// file: iterator0.C

#include <iostream>

// Das Zusammenspiel zwischen Datencontainern und Algorithmen
// geschieht in der Standard Template Library (STL) mithilfe 
// von 'Iteratoren'. 

#include <iterator>

// Folge von Daten wird als 'Iteratorrange' and den Algorithmus
// weitergegeben:   
//                      [first, beyond)
//                        /         \
//                     start     past-the-end

template <typename ReturnType, typename InputIterator>
ReturnType
total_sum(InputIterator first, InputIterator beyond)
{
  ReturnType  sum = ReturnType(0);
  while ( first != beyond)
  { sum += *first++; }    // besser?:   sum += *first; ++first;
  return sum;
} 


using namespace std;

int
main()
{
   istream_iterator<int>  start(cin); 
   istream_iterator<int>  ende;               // past-the-end 
   int S = total_sum<int>( start, ende);
   cout << endl << "Summe: " << S << endl;

   return 0;
}

