// file: iterators1.C

#include <iterator>

// Man unterscheidet 5 Iteratorkategorien:
// 
//  InputIterator     OutputIterator
//     = * ++             * = ++
// 
//          ForwardIterator
//             *, =, ++
// 
//        BidirectionalIterator
//           *, =, ++, --
// 
//         RandomAccessIterator       (z.B. Pointer)
//       *, =, ++, --, [], +, -


#include <cassert>
#include <fstream>
#include <vector>
#include <algorithm>          // sort template

using namespace std;

int
main(int argc, char** argv)
{
   assert( argc == 2);
   ifstream F(argv[1]);

   int C[10000];
   // vector<int> C(10000,0);
   // vector<int> C;
   // list<int> L;

   istream_iterator<int>  start(F);         // InputIterator
   istream_iterator<int>  ende;               
   
   int* beyond = copy( start, ende, C);
   // vector<int>::iterator beyond = copy( start, ende, C.begin() );
   // copy( start, ende, back_inserter(C) );
   // copy( start, ende, front_inserter(L) );

   sort( C, beyond);          // erfordert RandomAccessIterator und ' < '
   // sort( C.begin(), beyond);
   // sort( C.begin(), C.end());
   // ERROR: sort( L.begin(), L.end());
   // stattdessen bei Listen:
   // L.sort( L.begin(), L.end());

   copy( C, beyond, ostream_iterator<int>( cout, " ** "));   // (cout,"\n")
   // copy( C.begin(), beyond, ostream_iterator<int>( cout, " ** "));
   // copy( C.begin(), C.end(), ostream_iterator<int>( cout, " ** "));
   // copy( L.begin(), L.end(), ostream_iterator<int>( cout, " ** "));
   cout << endl;

   return 0;
}

